package com.izouma.awesomeadmin.web;

import java.util.*;

import com.izouma.awesomeadmin.util.ExportExcelUtil;
import org.apache.commons.lang.StringUtils;
import org.apache.shiro.authz.annotation.RequiresAuthentication;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.*;
import com.izouma.awesomeadmin.constant.AppConstant;
import com.izouma.awesomeadmin.dto.Page;
import com.izouma.awesomeadmin.dto.Result;
import com.izouma.awesomeadmin.model.MarketMapBoxDes;
import com.izouma.awesomeadmin.service.MarketMapBoxDesService;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

/**
*  controller类
*/
@Controller
@RequestMapping("/marketMapBoxDes")
public class MarketMapBoxDesController {

    @Autowired
    private MarketMapBoxDesService marketMapBoxDesService;

    /**
    * <p>获取全部记录。</p>
    */
    @RequiresAuthentication
    @RequestMapping(value = "/all", method = RequestMethod.GET)
    @ResponseBody
    public Result all(MarketMapBoxDes record) {
        List<MarketMapBoxDes> pp = marketMapBoxDesService.getMarketMapBoxDesList(record);
        return new Result(true, pp);
    }

    /**
    * <p>根据Id。</p>
    */
    @RequestMapping(value = "/getMarketMapBoxDes", method = RequestMethod.GET)
    @ResponseBody
    public Result getMarketMapBoxDes(@RequestParam(required = false, value = "id") String id) {
        MarketMapBoxDes data = marketMapBoxDesService.getMarketMapBoxDesById(id);
        return new Result(true, data);
    }

    /**
    * <p>根据条件获取。</p>
    */
    @RequestMapping(value = "/getOne", method = RequestMethod.GET)
    @ResponseBody
    public Result getOne(MarketMapBoxDes record) {
        MarketMapBoxDes data = marketMapBoxDesService.getMarketMapBoxDes(record);
        return new Result(true, data);
    }


    /**
    * <p>分页查询。</p>
    */
    @RequestMapping(value = "/page", method = RequestMethod.GET)
    @ResponseBody
    public Result page(Page page, MarketMapBoxDes record) {
        Map<String, Object> result = new HashMap<>();

        List<MarketMapBoxDes> pp =marketMapBoxDesService.getMarketMapBoxDesByPage(page, record);

        result.put(AppConstant.PAGE, page);
        result.put("pp", pp);
        return new Result(true, result);
    }


    /**
    * <p>保存。</p>
    */
    @RequestMapping(value = "/save", method = RequestMethod.POST)
    @ResponseBody
    public Result save(MarketMapBoxDes record) {
        boolean num = marketMapBoxDesService.createMarketMapBoxDes(record);
        if (num) {
        return new Result(true, record.getId());
        }
        return new Result(false, "保存异常");
    }

    /**
    * <p>更新信息。</p>
    */
    @RequestMapping(value = "/update", method = RequestMethod.POST)
    @ResponseBody
    public Result updateMarketMapBoxDes(MarketMapBoxDes record) {
        boolean num = marketMapBoxDesService.updateMarketMapBoxDes(record);
        if (num) {
        return new Result(true, "保存成功");
        }
        return new Result(false, "保存异常");
    }

    /**
    * <p>删除。</p>
    */
    @RequestMapping(value = "/del", method = RequestMethod.POST)
    @ResponseBody
    public Result deleteMarketMapBoxDes(MarketMapBoxDes record) {

        boolean num = marketMapBoxDesService.deleteMarketMapBoxDes(record);
        if (num) {
        return new Result(true, "删除成功");
        }
        return new Result(false, "删除异常");
    }

    /**
    * 导出Excel
    * @param request
    * @param response
    * @param record
    * @throws Exception
    */
    @RequestMapping(value = "/exportExcel", method = RequestMethod.GET)
    @ResponseBody
    public void exportExcel(HttpServletRequest request, HttpServletResponse response, MarketMapBoxDes record) throws Exception {

    List<MarketMapBoxDes> marketMapBoxDess = marketMapBoxDesService.getMarketMapBoxDesList(record);


        String sheetName = "market_map_box_des";
        String titleName = "货柜商品信息子表数据表";
        String fileName = "货柜商品信息子表表";
        int columnNumber = 12;
        int[] columnWidth = { 20,  20,  20,  20,  20,  20,  20,  20,  20,  20,  20,  20 };
        String[] columnName = {  "" ,   "删除标识" ,   "更新时间" ,   "更新人" ,   "创建时间" ,   "创建人" ,   "策划备注" ,   "所属货柜" ,   "商品" ,   "活动信息" ,   "商品介绍" ,   "LOGO"  };
        String[][] dataList = new String[marketMapBoxDess.size()][12];

        for (int i = 0; i < marketMapBoxDess.size(); i++) {

                        dataList[i][0] = String.valueOf(marketMapBoxDess.get(i).getId());
                        dataList[i][1] = String.valueOf(marketMapBoxDess.get(i).getDelFlag());
                        dataList[i][2] = String.valueOf(marketMapBoxDess.get(i).getUpdateTime());
                        dataList[i][3] = String.valueOf(marketMapBoxDess.get(i).getUpdateUser());
                        dataList[i][4] = String.valueOf(marketMapBoxDess.get(i).getCreateTime());
                        dataList[i][5] = String.valueOf(marketMapBoxDess.get(i).getCreateUser());
                        dataList[i][6] = String.valueOf(marketMapBoxDess.get(i).getRemark());
                        dataList[i][7] = String.valueOf(marketMapBoxDess.get(i).getBox());
                        dataList[i][8] = String.valueOf(marketMapBoxDess.get(i).getItemName());
                        dataList[i][9] = String.valueOf(marketMapBoxDess.get(i).getItemMess());
                        dataList[i][10] = String.valueOf(marketMapBoxDess.get(i).getItemDes());
                        dataList[i][11] = String.valueOf(marketMapBoxDess.get(i).getLogo());
                    }


        ExportExcelUtil.ExportWithResponse(sheetName, titleName, fileName,
        columnNumber, columnWidth, columnName, dataList, response);


        }
    }

